plugins {
    `java-library`
    `maven-publish`
}

repositories {
    mavenCentral()
    maven {
        setUrl("https://gitlab.com/api/v4/projects/35745143/packages/maven")
    }
}

dependencies {
    compileOnly("org.jetbrains:annotations:23.0.0")
}

publishing {
    repositories {
        if (rootProject.extra["isPublic"] == true) {
            maven {
                url = uri("https://gitlab.com/api/v4/projects/30862253/packages/maven")
                name = "gitlab"

                credentials(HttpHeaderCredentials::class) {
                    name = "Job-Token"
                    value = System.getenv()["CI_JOB_TOKEN"]
                }
                authentication {
                    create<HttpHeaderAuthentication>("header")
                }
            }
        }
        mavenLocal()
    }
}