plugins {
    id("inceptum.library-conventions")
}

dependencies {
    api("io.gitlab.jfronny:commons:${rootProject.extra["jfCommonsVersion"]}")
    api("io.gitlab.jfronny:commons-gson:${rootProject.extra["jfCommonsVersion"]}")
}

val javaVersion by extra(project.java.targetCompatibility)

projectDir.resolve("src/main/java/io/gitlab/jfronny/inceptum/common/BuildMetadata.java").writeText(
    """
    package io.gitlab.jfronny.inceptum.common;

    import io.gitlab.jfronny.commons.ComparableVersion;
    
    public class BuildMetadata {
        public static final ComparableVersion VERSION = new ComparableVersion("$version");
        public static final boolean IS_PUBLIC = ${rootProject.extra["isPublic"]};
        public static final boolean IS_RELEASE = ${rootProject.extra["isRelease"]};
        public static final int VM_VERSION = $javaVersion;
        public static final int WRAPPER_VERSION = ${rootProject.extra["wrapperVersion"]};
    }
    """.trimIndent())
