plugins {
    id("inceptum.application-standalone-conventions")
}

application {
    mainClass.set("io.gitlab.jfronny.inceptum.Inceptum")
}

dependencies {
    implementation(project(":launcher"))
    implementation(project(":launcher-cli"))
    implementation(project(":launcher-imgui"))
}

tasks.shadowJar {
    archiveClassifier.set(rootProject.extra["flavorProp"] as String)
    archiveBaseName.set("Inceptum")
    exclude("about.html")
    exclude("plugin.properties")
    exclude("META-INF/**")
}

(components["java"] as AdhocComponentWithVariants).withVariantsFromConfiguration(configurations["shadowRuntimeElements"]) {
    skip()
}

publishing {
    publications {
        if (rootProject.hasProperty("dist.platformOnly")) {
            create<MavenPublication>("shadowed") {
                artifact(tasks.shadowJar) {
                    builtBy(tasks.shadowJar)
                    artifactId = "Inceptum"
                }
            }
        } else {
            create<MavenPublication>("mavenJava") {
                from(components["java"])
            }
        }
    }
}