package io.gitlab.jfronny.inceptum.imgui.window.edit;

import imgui.ImGui;
import imgui.type.ImString;
import io.gitlab.jfronny.inceptum.imgui.control.Tab;
import io.gitlab.jfronny.inceptum.imgui.window.GuiUtil;
import io.gitlab.jfronny.inceptum.launcher.model.inceptum.InstanceMeta;

import java.util.LinkedList;
import java.util.List;

public class ArgumentsTab extends Tab {
    private final InstanceEditWindow window;
    private final ImString jvm = new ImString(GuiUtil.INPUT_FIELD_LENGTH);
    private final ImString client = new ImString(GuiUtil.INPUT_FIELD_LENGTH);
    private final ImString server = new ImString(GuiUtil.INPUT_FIELD_LENGTH);

    public ArgumentsTab(InstanceEditWindow window) {
        super("Arguments");
        this.window = window;
        if (window.instance.arguments == null) window.instance.arguments = new InstanceMeta.Arguments();
        if (window.instance.arguments.jvm == null) window.instance.arguments.jvm = new LinkedList<>();
        jvm.set(String.join("\n", window.instance.arguments.jvm));
        if (window.instance.arguments.client == null) window.instance.arguments.client = new LinkedList<>();
        client.set(String.join("\n", window.instance.arguments.client));
        if (window.instance.arguments.server == null) window.instance.arguments.server = new LinkedList<>();
        server.set(String.join("\n", window.instance.arguments.server));
    }

    @Override
    protected void renderInner() {
        if (ImGui.inputTextMultiline("JVM", jvm)) {
            window.instance.arguments.jvm = List.of(jvm.get().split("[\r\n]+"));
            window.save();
        }
        if (ImGui.inputTextMultiline("Client", client)) {
            window.instance.arguments.client = List.of(client.get().split("[\r\n]+"));
            window.save();
        }
        if (ImGui.inputTextMultiline("Server", server)) {
            window.instance.arguments.server = List.of(server.get().split("[\r\n]+"));
            window.save();
        }
    }
}
