package io.gitlab.jfronny.inceptum.launcher.system.install.steps;

import io.gitlab.jfronny.commons.io.JFiles;
import io.gitlab.jfronny.inceptum.common.MetaHolder;
import io.gitlab.jfronny.inceptum.launcher.model.inceptum.InstanceMeta;
import io.gitlab.jfronny.inceptum.launcher.system.install.Step;
import io.gitlab.jfronny.inceptum.launcher.system.mds.ModsDirScanner;
import io.gitlab.jfronny.inceptum.launcher.system.install.SetupStepInfo;

import java.io.IOException;
import java.nio.file.Path;
import java.util.concurrent.atomic.AtomicBoolean;

public class RunMdsStep implements Step {
    @Override
    public void execute(SetupStepInfo info, AtomicBoolean stopThread) throws IOException {
        info.setState("Running MDS");
        Path instance = MetaHolder.INSTANCE_DIR.resolve(info.name());
        ModsDirScanner.get(instance.resolve("mods"), JFiles.readObject(instance.resolve("instance.json"), InstanceMeta.class))
                .runOnce((path, iwModDescription) -> info.setState("Scanned " + path));
    }
}
